//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "VCLTee.TeeSeriesTextEd"
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner) : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
	try {

	SeriesData->BeginUpdate();

	SeriesTextSource1->FileName = GetCurrentDir() + "\\TestData.txt";
	SeriesTextSource1->Active   = true;

	} catch (...) { SeriesData->EndUpdate(); }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ShowYAxisValues(double YMin, double YMax)
{
	String str;

	str = "Min = " + FloatToStr(YMin) + ", Max = " + FloatToStr(YMax);
	Application->MessageBox(str.c_str(),L"Y Axis values",MB_OK | MB_ICONEXCLAMATION);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CBAutomaticYAxisClick(TObject *Sender)
{
	bool autoAxis;

	autoAxis = CBAutomaticYAxis->Checked;

	MainChart->LeftAxis->AutomaticMinimum = autoAxis;
	MainChart->LeftAxis->AutomaticMaximum = autoAxis;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::BtUseMinMaxPropClick(TObject *Sender)
{
	double 		yMin, yMax;
	TChartAxis *yAxis;

	yAxis = MainChart->LeftAxis;

	if( CBAdjustMaxMin->Checked )
		yAxis->AdjustMaxMin();

	yMin = yAxis->Minimum;
	yMax = yAxis->Maximum;

	ShowYAxisValues(yMin,yMax);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::BtUseCalcPosPointClick(TObject *Sender)
{
	double 		yMin, yMax;
	TChartAxis *yAxis;
	TRect			chartRect;

	chartRect = MainChart->ChartRect;

	yAxis = MainChart->LeftAxis;

	if( CBAdjustMaxMin->Checked )
		yAxis->AdjustMaxMin();

	yMin = yAxis->CalcPosPoint(chartRect.Bottom);
	yMax = yAxis->CalcPosPoint(chartRect.Top);

	ShowYAxisValues(yMin,yMax);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::BtTestYAxisRangeClick(TObject *Sender)
{
	double 		yMin, yMax;
	TChartAxis *yAxis;
	TRect			chartRect;

	chartRect = MainChart->ChartRect;

	yAxis = MainChart->LeftAxis;

	MainChart->LeftAxis->AutomaticMinimum = false;
	MainChart->LeftAxis->AutomaticMaximum = false;

	yAxis->SetMinMax(0,0);

	try {

	MainChart->AutoRepaint = false;

	SeriesTextSource1->Active = false;
	SeriesTextSource1->Active = true;

	} __finally	{ MainChart->AutoRepaint = true; }

	MainChart->LeftAxis->AutomaticMinimum = true;
	MainChart->LeftAxis->AutomaticMaximum = true;

	if( CBAdjustMaxMin->Checked )
		yAxis->AdjustMaxMin();

	yMin = yAxis->CalcPosPoint(chartRect.Bottom);
	yMax = yAxis->CalcPosPoint(chartRect.Top);

	ShowYAxisValues(yMin,yMax);

	CBAutomaticYAxis->Checked = true;
}
//---------------------------------------------------------------------------

